import 'dart:async';
import 'dart:html';
import 'package:web_ui/web_ui.dart';
import 'package:bot/bot.dart';
import 'package:widget/effects.dart';
import 'package:widget/widget.dart';

// TODO: option to enable/disable wrapping. Disable buttons if the end is hit...

class Carousel extends WebComponent {
  final ShowHideEffect _fromTheLeft = new SlideEffect(xStart: HorizontalAlignment.LEFT);
  final ShowHideEffect _fromTheRight = new SlideEffect(xStart: HorizontalAlignment.RIGHT);

  static const _duration = 2000;

  SwapComponent get _swap => this.query('x-carousel > x-swap').xtag;

  Future<bool> next() => _moveDelta(true);

  Future<bool> previous() => _moveDelta(false);

  Future<bool> _moveDelta(bool doNext) {
    final swap = _swap;
    assert(swap != null);
    if(swap.items.length == 0) {
      return new Future.immediate(false);
    }

    assert(doNext != null);
    final delta = doNext ? 1 : -1;

    ShowHideEffect showEffect, hideEffect;
    if(doNext) {
      showEffect = _fromTheRight;
      hideEffect = _fromTheLeft;
    } else {
      showEffect = _fromTheLeft;
      hideEffect = _fromTheRight;
    }

    final activeIndex = _swap.activeItemIndex;

    final newIndex = (activeIndex + delta) % _swap.items.length;

    return _swap.showItemAtIndex(newIndex, effect: showEffect, hideEffect: hideEffect, duration: _duration);
  }
}
